package com.zanxiang.sdk.controller;

import com.alibaba.nacos.common.utils.IPUtil;
import com.zanxiang.common.domain.ResultMap;
import com.zanxiang.common.enums.PayWayEnum;
import com.zanxiang.sdk.domain.bo.ProductPayParamBO;
import com.zanxiang.sdk.domain.params.ProductPayParam;
import com.zanxiang.sdk.service.Impl.pay.PayService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jdom.JDOMException;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * 支付公共入口
 *
 * @author xufeng
 * @date 2022/6/8 14:49
 */
@Api(tags = "支付公共入口")
@RestController
@RequestMapping(value = "/pay")
public class PayController {

    @Resource
    private PayService payService;

    @ApiOperation(value = "支付参数生成")
    @GetMapping(value = "/create")
    public ResultMap create(@RequestBody ProductPayParam product) {
        String userId = "1";
        ProductPayParamBO bo = new ProductPayParamBO();
        bo.setUserId(userId);
        bo.setPayDevice(product.getPayDevice());
        bo.setSpbillCreateIp(IPUtil.localHostIP());
        bo.setOutTradeNo(product.getOrderId());
        bo.setPayWay(product.getPayWay());
        return payService.payCreate(bo);
    }

    @ApiOperation(value = "支付宝支付异步回调(二维码、H5、网站)")
    @RequestMapping(value = "notify", method = RequestMethod.POST)
    public String alipayNotify(HttpServletRequest request, HttpServletResponse response) throws IOException, JDOMException {
        return payService.notify(request, response, PayWayEnum.ALIPAY.getNum());
    }

    @ApiOperation(value = "微信支付")
    @RequestMapping(value = "wxPayNotify", method = RequestMethod.POST)
    public String wxPayNotify(HttpServletRequest request, HttpServletResponse response) throws IOException, JDOMException {
        return payService.notify(request, response, PayWayEnum.WXPAY.getNum());
    }

    @ApiOperation(value = "支付宝支付同步回调(二维码、H5、网站)")
    @RequestMapping(value = "alipaySynNotify", method = RequestMethod.POST)
    public ResultMap synNotify(HttpServletRequest request) {
        return payService.synNotify(request, PayWayEnum.ALIPAY.getNum());
    }

}
