package com.zanxiang.sdk.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.zanxiang.common.domain.ResultVo;
import com.zanxiang.sdk.domain.dto.UserDTO;
import com.zanxiang.sdk.domain.entity.User;
import com.zanxiang.sdk.domain.params.LoginMobileParam;
import com.zanxiang.sdk.domain.params.LoginPasswordParam;
import com.zanxiang.sdk.domain.vo.UserLoginVO;

import javax.servlet.http.HttpServletRequest;

/**
 * @author : lingfeng
 * @time : 2022-06-08
 * @description : 用户信息
 */
public interface IUserService extends IService<User> {

    /**
     * 用户名密码登录
     *
     * @param userLoginParam : 登录参数
     * @param request        : HttpServletRequest
     * @return : 返回登录token
     */
    ResultVo<UserLoginVO> loginPassword(LoginPasswordParam userLoginParam, HttpServletRequest request);

    /**
     * 手机号登录
     *
     * @param loginMobileParam : 手机号登录参数
     * @param request          : HttpServletRequest
     * @return : 返回登录信息
     */
    ResultVo<UserLoginVO> loginMobile(LoginMobileParam loginMobileParam, HttpServletRequest request);

    /**
     * 检查用户手机号是否存在
     *
     * @param mobile : 用户手机号
     * @return : 返回用户信息
     */
    UserDTO getUserInfoByMobile(String mobile);
}
