package com.zanxiang.sdk.service.Impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zanxiang.sdk.domain.entity.User;
import com.zanxiang.sdk.domain.entity.UserLoginLog;
import com.zanxiang.sdk.mapper.UserLoginLogMapper;
import com.zanxiang.sdk.service.IUserLoginLogService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

/**
 * @author : lingfeng
 * @time : 2022-06-13
 * @description : 用户登录日志
 */
@Slf4j
@Service
public class UserLoginLogServiceImpl extends ServiceImpl<UserLoginLogMapper, UserLoginLog> implements IUserLoginLogService {

    /**
     * 添加用户登录日志
     *
     * @param user   : 用户信息
     * @param gameId : 游戏id
     */
    @Override
    public void addUserLoginLog(String realIp, User user, Long gameId) {
        UserLoginLog userLoginLog = new UserLoginLog(realIp, user, gameId);
        super.save(userLoginLog);
    }
}
